
import com.imsl.io.*;
import com.imsl.math.*;
import java.io.*;
import java.text.*;

public class SparseLPEx2 {

    public static void main(String args[]) throws Exception {
        // Read from MPS file.
        InputStream stream = SparseLPEx2.class.getResourceAsStream("afiro");
        Reader reader = new InputStreamReader(stream);
        MPSReader mps = new MPSReader();
        mps.read(reader);

        // Solve problem.
        SparseLP lp = new SparseLP(mps);
        lp.setPresolve(6);
        lp.solve();

        // Print solution.     
        System.out.println("Problem Name: " + mps.getName());
        System.out.printf("Objective:  %.2f\n", lp.getOptimalValue());

        NumberFormat nf = NumberFormat.getInstance();
        nf.setMaximumFractionDigits(1);
        nf.setMinimumFractionDigits(1);

        PrintMatrixFormat mf = new PrintMatrixFormat();
        mf.setNumberFormat(nf);
        mf.setNoColumnLabels();

        new PrintMatrix("Solution:").print(mf, lp.getSolution());

        // Close all resources.
        reader.close();
        stream.close();
    }
}
